## ros-indigo-object-recognition-transparent-objects 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(object_recognition_transparent_objects)

find_package(Boost REQUIRED program_options signals)
find_package(PCL REQUIRED)
find_package(catkin QUIET)

if (catkin_FOUND)
    find_package(catkin REQUIRED ecto ecto_opencv object_recognition_core opencv_candidate)
        catkin_package(INCLUDE_DIRS include)

    #install targets for all things python
    catkin_python_setup()

    find_package(ecto REQUIRED)
    find_package(ecto_opencv REQUIRED)
    find_package(object_recognition_core REQUIRED)
else()
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

find_package(OpenCV REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(SYSTEM ${object_recognition_core_INCLUDE_DIRS})

add_subdirectory(src)

if (${ecto_FOUND} AND ${object_recognition_core_FOUND})
    add_subdirectory(cells)
endif()

# deal with the tests
option(BUILD_TEST "Build tests" ON)
if(BUILD_TEST)
  enable_testing()
  add_subdirectory(test)
endif()  

# add docs
ecto_sphinx(${CMAKE_CURRENT_SOURCE_DIR}/doc/source doc)

=== cells/CMakeLists.txt ===
ectomodule(transparent_objects_cells DESTINATION ${PROJECT_NAME}
                                     INSTALL
    module.cpp
    train.cpp
    detect.cpp
    db_transparent_objects.cpp
    modelFiller.cpp
    )

include_directories(SYSTEM ${catkin_INCLUDE_DIRS}
                           ${PCL_INCLUDE_DIRS}
)

link_ecto(transparent_objects_cells
    ${PCL_LIBRARIES}
    ${Boost_LIBRARIES}
    ${catkin_LIBRARIES}
    edges_pose_refiner
)

set(ADD_COLLISION_OBJECTS False)
if (ADD_COLLISION_OBJECTS)
    include_directories(/opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/planning_environment/include/
                        /opt/ros/fuerte/stacks/arm_navigation/planning_models/include/
                        /opt/ros/fuerte/stacks/arm_navigation/geometric_shapes/include/
                        /opt/ros/fuerte/stacks/robot_model/urdf/include/
                        /opt/ros/fuerte/stacks/robot_model/urdf_parser/include/
                        /opt/ros/fuerte/stacks/robot_model/urdf_interface/include/
                        /opt/ros/fuerte/stacks/robot_model/collada_parser/include/
                        /opt/ros/fuerte/stacks/geometry/tf/include/
                        /opt/ros/fuerte/stacks/geometry_experimental/tf2/include/
                        /opt/ros/fuerte/stacks/arm_navigation/collision_space/include/
                        /opt/ros/fuerte/stacks/physics_ode/opende/opende/include/
    )
    add_definitions(-DADD_COLLISION_OBJECTS)
    find_package(ROS COMPONENTS roscpp)
    link_ecto(transparent_objects_cells ${roscpp_LIBRARIES})
endif()

=== src/CMakeLists.txt ===
#TDS: dont glob together sources.
set(src 
    edgeModel.cpp
    glassSegmentator.cpp
    localPoseRefiner.cpp
    pclProcessing.cpp
    pinholeCamera.cpp
    poseError.cpp
    poseEstimator.cpp
    poseRT.cpp
    silhouette.cpp
    TODBaseImporter.cpp
    detector.cpp
    utils.cpp
    nonMaximumSuppression.cpp
    chamfer_matching/chamfer_matching.cpp
    tableSegmentation.cpp
    pcl.cpp
    pclVisualization.cpp
)

include_directories(SYSTEM
                    ${PCL_INCLUDE_DIRS}
                    ${ecto_opencv_INCLUDE_DIRS}
)

#EAR: is there a reason to list headers in this target?
add_library(edges_pose_refiner SHARED
    ${src}
    )

set_target_properties(edges_pose_refiner PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")

# Thanks a lot, vtk.  Why are we dependent on vtk?
add_definitions(-Wno-deprecated)


set(src_fdcm
    fdcm/image/DistanceTransform.cpp
    fdcm/fitline/LFLineFitter.cpp
    fdcm/fitline/LFLineSegment.cpp
    fdcm/fdcm/LMDistanceImage.cpp
    fdcm/fdcm/LMDirectionalIntegralDistanceImage.cpp
    fdcm/fdcm/EIEdgeImage.cpp
    fdcm/fdcm.cpp
)

add_library(fdcm SHARED
    ${src_fdcm}
    )
target_link_libraries(fdcm
                      ${PCL_LIBRARIES}
                      ${OpenCV_LIBRARIES}
)

set(MODEL_CAPTURE False)
if(MODEL_CAPTURE)
    set(src_mrf
        mrf/BP-S.cpp
        mrf/GCoptimization.cpp
        mrf/ICM.cpp
        mrf/maxflow.cpp
        mrf/mrf.cpp
        mrf/TRW-S.cpp
        mrf/graph.cpp
        mrf/LinkedBlockList.cpp
        mrf/MaxProdBP.cpp
        mrf/regions-maxprod.cpp
    )

    add_library(mrf SHARED
        ${src_mrf}
        )
    set_target_properties(mrf PROPERTIES COMPILE_FLAGS "-W -Wall -DUSE_64_BIT_PTR_CAST")



    set(src_model_capture
        modelCapture/modelCapturer.cpp
    )
    add_library(model_capture SHARED
        ${src_model_capture}
        )
    set_target_properties(model_capture PROPERTIES COMPILE_FLAGS "-fopenmp" LINK_FLAGS "-fopenmp")
    target_link_libraries(model_capture
                          edges_pose_refiner
                          mrf
    )



    add_executable(captureModel apps/captureModel.cpp)
    set_target_properties(captureModel PROPERTIES
      COMPILE_FLAGS "-fopenmp"
      LINK_FLAGS "-fopenmp"
      )
    target_link_libraries(captureModel edges_pose_refiner
                                       model_capture
                                       mrf
                                       ${PYTHON_LIBRARIES}
    )
endif()

target_link_libraries(edges_pose_refiner
                      fdcm
                      ${PCL_LIBRARIES}
                      ${OpenCV_LIBRARIES}
                      ${opencv_candidate_LIBRARIES}
)

install(TARGETS edges_pose_refiner fdcm
  DESTINATION lib
  )



add_executable(sample ../sample/sample.cpp)
# not sure why but we need Python on Lucid
find_package(PythonLibs)
target_link_libraries(sample edges_pose_refiner
                             ${PYTHON_LIBRARIES}
                             ${PCL_LIBRARIES}
)

set(USE_ON_ROBOT False)
if (USE_ON_ROBOT)
    add_definitions(-DdDOUBLE)
    #TODO: use macros
    include_directories(/opt/ros/fuerte/stacks/pr2_object_manipulation/perception/tabletop_object_detector/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/pr2_object_manipulation/perception/tabletop_object_detector/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/object_manipulation/household_objects_database_msgs/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/object_manipulation/object_manipulation_msgs/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/pr2_object_manipulation/perception/tabletop_collision_map_processing/srv_gen/cpp/include/

                        #dependencies for moving arm to a side
                        /opt/ros/fuerte/stacks/object_manipulation/object_manipulator/include/
                        /opt/ros/fuerte/stacks/geometry/tf/include/
                        /opt/ros/fuerte/stacks/geometry/tf/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/bullet/include/
                        /opt/ros/fuerte/stacks/geometry/tf/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/geometry/eigen_conversions/include/
                        /opt/ros/fuerte/stacks/arm_navigation/kinematics_msgs/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/kinematics_msgs/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/include/
                        /opt/ros/fuerte/stacks/pr2_controllers/pr2_controllers_msgs/msg_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation_experimental/interpolated_ik_motion_planner/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/planning_environment/include/
                        /opt/ros/fuerte/stacks/arm_navigation/planning_models/include/
                        /opt/ros/fuerte/stacks/arm_navigation/geometric_shapes/include/
                        /opt/ros/fuerte/stacks/robot_model/urdf/include/
                        /opt/ros/fuerte/stacks/robot_model/urdf_parser/include/
                        /opt/ros/fuerte/stacks/robot_model/urdf_interface/include/
                        /opt/ros/fuerte/stacks/robot_model/collada_parser/include/
                        /opt/ros/fuerte/stacks/arm_navigation/collision_space/include/
                        /opt/ros/fuerte/stacks/physics_ode/opende/opende/include/
                        /opt/ros/fuerte/stacks/object_manipulation/object_manipulation_msgs/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/pr2_mechanism/pr2_mechanism_msgs/srv_gen/cpp/include/
                        /opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/msg_gen/cpp/include/
    )

    add_executable(pickAndPlace apps/pickAndPlace.cpp)

    find_package(ROS COMPONENTS roscpp actionlib)

    message("libs: ${object_manipulator_LIBRARIES}")
    target_link_libraries(pickAndPlace ${roscpp_LIBRARIES}
                                       ${Boost_LIBRARIES}
                                       ${actionlib_LIBRARIES}
                                       /opt/ros/fuerte/stacks/arm_navigation/planning_environment/lib/libplanning_environment.so
                                       /opt/ros/fuerte/stacks/geometry/tf/lib/libtf.so
                                       /opt/ros/fuerte/stacks/object_manipulation/object_manipulator/lib/libobject_manipulator_tools.so
                                       /opt/ros/fuerte/stacks/robot_model/colladadom/lib/libminizip.so
                         )
endif()

#add_executable(transparentExperiments transparent_experiments/transparentExperiments.cpp)
#set_target_properties(transparentExperiments
#  PROPERTIES
#  COMPILE_FLAGS "-std=c++0x"
#  )
#target_link_libraries(transparentExperiments edges_pose_refiner
#                                             ${PYTHON_LIBRARIES}
#)

#add_executable(createObjectMask apps/createObjectMask.cpp)
#target_link_libraries(createObjectMask edges_pose_refiner
#                                       ${PYTHON_LIBRARIES}
#)

#add_executable(kinfuSegmentation apps/kinfuSegmentation.cpp)
#target_link_libraries(kinfuSegmentation edges_pose_refiner)

#add_executable(poseEstimationDemo apps/poseEstimationDemo.cpp)
#set_target_properties(poseEstimationDemo
#  PROPERTIES
#  COMPILE_FLAGS "-std=c++0x"
#  )
#target_link_libraries(poseEstimationDemo edges_pose_refiner
#                                         ${PYTHON_LIBRARIES}
#)

#add_executable(evaluateLine2D line2D/evaluation.cpp line2D/line2D.cpp)
#set_target_properties(evaluateLine2D
#  PROPERTIES
#  COMPILE_FLAGS "-std=c++0x"
#  )
#target_link_libraries(evaluateLine2D edges_pose_refiner
#                                     ${PYTHON_LIBRARIES}
#)

#add_executable(labelDataset apps/labelDataset.cpp)
#set_target_properties(labelDataset
#  PROPERTIES
#  COMPILE_FLAGS "-std=c++0x"
#  )
#target_link_libraries(labelDataset edges_pose_refiner
#                                   ${PYTHON_LIBRARIES}#
#)

#add_executable(labelSegmentation apps/labelSegmentation.cpp)
#target_link_libraries(labelSegmentation edges_pose_refiner
#                                        ${PYTHON_LIBRARIES}
#)

#add_executable(showTable apps/showTable.cpp)
#set_target_properties(showTable PROPERTIES
#    COMPILE_FLAGS "-fopenmp"
#    LINK_FLAGS "-fopenmp"
#)
#target_link_libraries(showTable edges_pose_refiner
#                                ${PYTHON_LIBRARIES}
#)

#add_executable(reconstructRotationalModel_singleImage apps/reconstructRotationalModel_singleImage.cpp)
#target_link_libraries(reconstructRotationalModel_singleImage edges_pose_refiner
#                                                 ${OpenCV_LIBRARIES}
#)

add_executable(runDetectionOnDataset apps/runDetectionOnDataset.cpp)
set_target_properties(runDetectionOnDataset PROPERTIES
    COMPILE_FLAGS "-fopenmp"
    LINK_FLAGS "-fopenmp"
)
target_link_libraries(runDetectionOnDataset edges_pose_refiner)

#add_executable(writeVideo apps/writeVideo.cpp)
#target_link_libraries(writeVideo ${OpenCV_LIBRARIES})

set(WITH_ROS FALSE)
if (${WITH_ROS})
    include_directories(${catkin_INCLUDE_DIRS})

    add_executable(dumpBagFile apps/bags/dumpBagFile.cpp)

    target_link_libraries(dumpBagFile ${Boost_LIBRARIES}
                                      ${catkin_LIBRARIES}
                                      ${OpenCV_LIBRARIES}
                                      ${PYTHON_LIBRARIES}
    )
endif()

=== debian/changelog ===
ros-indigo-object-recognition-transparent-objects (0.4.0-0trusty) trusty; urgency=high

  * Fix check regarding whether the file is opened
  * drop Fuerte support
  * Contributors: Jordi Pages, Vincent Rabaud

 -- Ilya Lysenkov <ilya.lysenkov@itseez.com>  Sat, 26 Jul 2014 22:00:00 -0000

ros-indigo-object-recognition-transparent-objects (0.3.18-0trusty) trusty; urgency=high

  * fix dependencies with PCL

 -- Ilya Lysenkov <ilya.lysenkov@itseez.com>  Wed, 28 Aug 2013 20:27:21 +0200

=== debian/control ===
Source: ros-indigo-object-recognition-transparent-objects
Section: misc
Priority: extra
Maintainer: Ilya Lysenkov <ilya.lysenkov@itseez.com>
Build-Depends: debhelper (>= 9.0.0), libopenni-dev, ros-indigo-catkin, ros-indigo-ecto, ros-indigo-object-recognition-core, ros-indigo-pcl-ros
Homepage: http://wg-perception.github.io/transparent_objects
Standards-Version: 3.9.2

Package: ros-indigo-object-recognition-transparent-objects
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenni-dev, ros-indigo-ecto, ros-indigo-ecto-opencv, ros-indigo-object-recognition-core, ros-indigo-pcl-ros
Description: A technique to recognize and estimate poses of transparent objects

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-object-recognition-transparent-objects//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
